#lang racket

(require "lascheme-private.rkt")

(provide ^up ^down)

(define (c-c-m key) 
  (continuation-mark-set->list
   (current-continuation-marks) 
   key))

(define-syntax (w-c-m stx)
  (syntax-case stx ()
    [(_ tag mark body)
     (syntax ((lambda (x) x)
              (with-continuation-mark tag mark body)))]))

;;; level-shifting operators ;; LEVEL
;; up
(define-syntax ^up
  (lambda (stx)
    (syntax-case stx ()
      [(_ body ...)
       (syntax/loc stx (parameterize ((current-level (+ 1 (current-level))))
                         (w-c-m 'current-level (current-level)
                                (begin body ...))))])))

;; down
(define-syntax ^down
  (lambda (stx)
    (syntax-case stx ()
      [(_ body ...)
       (syntax/loc stx (parameterize ((current-level (- (current-level) 1)))
                         (w-c-m 'current-level (current-level)
                                (begin body ...))))])))