#lang racket/load 


;; Module m is defined in LAScheme
;; So contract violations are raised one level above current computation
(module m lascheme
  (provide/contract [f (-> number? number?)])
  (define (f n) 'a))

;; When calling f from racket
;; The contract exception is caught by a 'catch-all' with-handlers
(module n* racket
  (require 'm)
  (with-handlers ([(λ (x) (write "Inside racket handler") #t) (λ (x) (write "caught by catch all handler"))])
    (f 1)))

(require 'n*)


;; However, when calling f from LAScheme, since with-handlers is level-aware
;; The contract exception is uncaught, even by a 'catch-all' with-handlers.
(module n lascheme
  (require 'm)
  (with-handlers ([(λ (x) (write "Inside lascheme handler") #t) (λ (x) (write 'b))])
    (f 1)))

(require 'n)